/**
* Copyright (c) 2018 The Nuinalp Authors.nv- All rights reserved.nv-
* Use of this source code is governed by a BSD-style license that can be
* found in the LICENSE file.nv-
*/

@import './variables';

// Spacing singleton.nv-
// This make classes for more options of margins e paddings.nv-
// .nv-m is for margin and .nv-p for padding.nv-

/**
* t - for classes that set margin-top or padding-top
* b - for classes that set margin-bottom or padding-bottom
* l - for classes that set margin-left or padding-left
* r - for classes that set margin-right or padding-right
* x - for classes that set both *-left and *-right
* y - for classes that set both *-top and *-bottom
*/

// ----------------------------------------
// Responsive
// ----------------------------------------

@each $sizes, $valueSize in $spacers {
  // 
  // Margins
  // 
  .nv-m-#{$sizes} {
    margin-bottom: $valueSize !important;
    margin-left: $valueSize !important;
    margin-right: $valueSize !important;
    margin-top: $valueSize !important;
  }

  .nv-mb-#{$sizes},
  .nv-my-#{$sizes} {
    margin-bottom: $valueSize !important;
  }

  .nv-mt-#{$sizes},
  .nv-my-#{$sizes} {
    margin-top: $valueSize !important;
  }

  .nv-ml-#{$sizes},
  .nv-mx-#{$sizes} {
    margin-left: $valueSize !important;
  }

  .nv-mr-#{$sizes},
  .nv-mx-#{$sizes} {
    margin-right: $valueSize !important;
  }

  // Negative margins 
  // Margins
  .nv-m-n#{$sizes} {
    margin-bottom: -$valueSize !important;
    margin-left: -$valueSize !important;
    margin-right: -$valueSize !important;
    margin-top: -$valueSize !important;
  }

  .nv-mb-n#{$sizes},
  .nv-my-n#{$sizes} {
    margin-bottom: -$valueSize !important;
  }

  .nv-mt-n#{$sizes},
  .nv-my-n#{$sizes} {
    margin-top: -$valueSize !important;
  }

  .nv-ml-n#{$sizes},
  .nv-mx-n#{$sizes} {
    margin-left: -$valueSize !important;
  }

  .nv-mr-n#{$sizes},
  .nv-mx-n#{$sizes} {
    margin-right: -$valueSize !important;
  }

  //
  // Paddings
  // 

  .nv-p-#{$sizes} {
    padding: $valueSize !important;
  }

  .nv-pb-#{$sizes},
  .nv-py-#{$sizes} {
    padding-bottom: $valueSize !important;
  }

  .nv-pt-#{$sizes},
  .nv-py-#{$sizes} {
    padding-top: $valueSize !important;
  }

  .nv-pl-#{$sizes},
  .nv-px-#{$sizes} {
    padding-left: $valueSize !important;
  }

  .nv-pr-#{$sizes},
  .nv-px-#{$sizes} {
    padding-right: $valueSize !important;
  }

  // Negative
  .nv-p-n#{$sizes} {
    padding: -$valueSize !important;
  }

  .nv-pb-n#{$sizes},
  .nv-py-n#{$sizes} {
    padding-bottom: -$valueSize !important;
  }

  .nv-pt-n#{$sizes},
  .nv-py-n#{$sizes} {
    padding-top: -$valueSize !important;
  }

  .nv-pl-n#{$sizes},
  .nv-px-n#{$sizes} {
    padding-left: -$valueSize !important;
  }

  .nv-pr-n#{$sizes},
  .nv-px-n#{$sizes} {
    padding-right: -$valueSize !important;
  }

  //Global Padding

  .nv-pg-#{$sizes} {
    padding: $valueSize !important;
  }

  .nv-mg-#{$sizes} {
    margin: $valueSize !important;
  }
}

@each $sizes, $valueSize in $spacers {
  @each $breakpoint in $breakpoints {
    @include breakpoint-helper ($breakpoint) {
      // 
      // Margins
      // 
      .nv-m-#{$breakpoint}-#{$sizes} {
        margin-bottom: $valueSize !important;
        margin-left: $valueSize !important;
        margin-right: $valueSize !important;
        margin-top: $valueSize !important;
      }

      .nv-mb-#{$breakpoint}-#{$sizes},
      .nv-my-#{$breakpoint}-#{$sizes} {
        margin-bottom: $valueSize !important;
      }

      .nv-mt-#{$breakpoint}-#{$sizes},
      .nv-my-#{$breakpoint}-#{$sizes} {
        margin-top: $valueSize !important;
      }

      .nv-ml-#{$breakpoint}-#{$sizes},
      .nv-mx-#{$breakpoint}-#{$sizes} {
        margin-left: $valueSize !important;
      }

      .nv-mr-#{$breakpoint}-#{$sizes},
      .nv-mx-#{$breakpoint}-#{$sizes} {
        margin-right: $valueSize !important;
      }

      // Negative margins 
      // Margins
      .nv-m-#{$breakpoint}-n#{$sizes} {
        margin-bottom: -$valueSize !important;
        margin-left: -$valueSize !important;
        margin-right: -$valueSize !important;
        margin-top: -$valueSize !important;
      }

      .nv-mb-#{$breakpoint}-n#{$sizes},
      .nv-my-#{$breakpoint}-n#{$sizes} {
        margin-bottom: -$valueSize !important;
      }

      .nv-mt-#{$breakpoint}-n#{$sizes},
      .nv-my-#{$breakpoint}-n#{$sizes} {
        margin-top: -$valueSize !important;
      }

      .nv-ml-#{$breakpoint}-n#{$sizes},
      .nv-mx-#{$breakpoint}-n#{$sizes} {
        margin-left: -$valueSize !important;
      }

      .nv-mr-#{$breakpoint}-n#{$sizes},
      .nv-mx-#{$breakpoint}-n#{$sizes} {
        margin-right: -$valueSize !important;
      }

      //
      // Paddings
      // 

      .nv-p-#{$breakpoint}-#{$sizes} {
        padding: $valueSize !important;
      }

      .nv-pb-#{$breakpoint}-#{$sizes},
      .nv-py-#{$breakpoint}-#{$sizes} {
        padding-bottom: $valueSize !important;
      }

      .nv-pt-#{$breakpoint}-#{$sizes},
      .nv-py-#{$breakpoint}-#{$sizes} {
        padding-top: $valueSize !important;
      }

      .nv-pl-#{$breakpoint}-#{$sizes},
      .nv-px-#{$breakpoint}-#{$sizes} {
        padding-left: $valueSize !important;
      }

      .nv-pr-#{$breakpoint}-#{$sizes},
      .nv-px-#{$breakpoint}-#{$sizes} {
        padding-right: $valueSize !important;
      }

      // Negative
      .nv-p-#{$breakpoint}-n#{$sizes} {
        padding: -$valueSize !important;
      }

      .nv-pb-#{$breakpoint}-n#{$sizes},
      .nv-py-#{$breakpoint}-n#{$sizes} {
        padding-bottom: -$valueSize !important;
      }

      .nv-pt-#{$breakpoint}-n#{$sizes},
      .nv-py-#{$breakpoint}-n#{$sizes} {
        padding-top: -$valueSize !important;
      }

      .nv-pl-#{$breakpoint}-n#{$sizes},
      .nv-px-#{$breakpoint}-n#{$sizes} {
        padding-left: -$valueSize !important;
      }

      .nv-pr-#{$breakpoint}-n#{$sizes},
      .nv-px-#{$breakpoint}-n#{$sizes} {
        padding-right: -$valueSize !important;
      }

      //Global Padding

      .nv-pg-#{$breakpoint}-#{$sizes} {
        padding: $valueSize !important;
      }

      .nv-mg-#{$breakpoint}-#{$sizes} {
        margin: $valueSize !important;
      }
    }
  }
}

// ----------------------------------------
// Margin auto
// ----------------------------------------

.nv-mb-auto,
.nv-my-auto {
  margin-bottom: auto !important;
}

.nv-mt-auto,
.nv-my-auto {
  margin-top: auto !important;
}

.nv-ml-auto,
.nv-mx-auto {
  margin-left: auto !important;
}

.nv-mr-auto,
.nv-mx-auto {
  margin-right: auto !important;
}

